// Header file for PSPedict project.

// ============
// ukanji array
// ============
#define MAX_UCODE    50
#define MAX_KANJI    34
#define MAX_KANA     56
#define MAX_DESCRIP 150
#define MAX_LINES   68786 // Check if using proper names.
#define MAX_LINES_COMP   10548
#define MAX_LINES_LEGAL   3233
#define MAX_LINES_LIFE   31383
#define MAX_LINES_CUSTOM 20000
#define MAX_TC_FILEPOS_COUNT 3
//#define MAX_LINES_NAMES  over 167000. Too many to impliment.

// ================
// ukanjidict array
// ================
#define MAX_ONYOMI		   40
#define MAX_KUNYOMI		  280
#define MAX_KD_DESCRIP    150
#define MAX_KANJIDICT    6354
#define PROC_ONYOMI         0
#define PROC_KUNYOMI        1
#define PROC_ENG            2

// ====
// Menu
// ====
#define CURSOR_X			502
#define CURSOR_Y			  0
#define CURSOR_WIDTH		  9
#define CURSOR_HEIGHT        16

#define MENU_X                0
#define MENU_Y              191
#define MENU_WIDTH (AA_SCREEN_WIDTH - 1)
#define MENU_HEIGHT          80
#define MENU_MAX_TICK        40
// Menu Status
#define M_OPEN                0
#define M_OPENING             1
#define M_CLOSED              2
#define M_CLOSING             3

#define MENU_ICON_WIDTH					15
#define MENU_ICON_HEIGHT				15
#define MENU_ICON_SRC_X				   496
#define MENU_ICON_EXIT_SRC_Y			16
#define MENU_ICON_SAVE_SRC_Y			32
#define MENU_ICON_SEARCH_SRC_Y			48
#define MENU_ICON_LOAD_SRC_Y			64
#define MENU_ICON_OPT_SRC_Y				80
#define MENU_ICON_FIND_SRC_Y			96
#define MENU_ICON_KDICT_SRC_Y			112
#define MENU_ICON_STUDY_SRC_Y			128
#define MENU_ICON_STUDY_ADD_SRC_Y		144
#define MENU_ICON_STUDY_MINUS_SRC_Y		160
#define MENU_ICON_STUDY_MINUS_ALL_SRC_Y 176
#define MENU_ICON_EDICT_SRC_Y			192 // New 24/10/09
#define MENU_ICON_EDICT_LOAD_SRC_Y		208 // New 26/10/09

#define MENU_ICON_Y						211
#define MENU_ICON_LOAD_X				 16
#define MENU_ICON_SAVE_X				 64
#define MENU_ICON_SEARCH_X				160
#define MENU_ICON_OPT_X					256
#define MENU_ICON_FIND_X				208
#define MENU_ICON_EXIT_X				432
#define MENU_ICON_OFFSET				 10
#define MENU_ICON_KDICT_X				112
#define MENU_ICON_EDICT_X				112
#define MENU_ICON_STUDY_X				352
#define MENU_ICON_STUDY_ADD_X			304
#define MENU_ICON_STUDY_MINUS_X		     16
#define MENU_ICON_STUDY_MINUS_ALL_X	     64
#define MENU_ICON_EDICT_LOAD_X			394 // New 26/10/09

#define MENU_EXIT              0
#define MENU_SAVE              1
#define MENU_SEARCH            2
#define MENU_LOAD              3
#define MENU_OPT               4
#define MENU_FIND              5
//#define MAX_MENU_ICON        6
#define MENU_KDICT             6
#define MENU_STUDY             7
#define MENU_STUDY_ADD         8
#define MENU_STUDY_MINUS       9
#define MENU_STUDY_MINUS_ALL  10
#define MENU_EDICT            11
#define MENU_EDICT_LOAD       12
#define MAX_MENU_ICON         13

// Returned from CheckMenu if the option button was clicked.
// Used to store old search and sort variables for comparison.
#define MENU_OPT_CLICKED       1

// =======
// Options
// =======
#define OPT_SEARCH_START		   0
#define OPT_SEARCH_ANY			   1

// Radio Buttons
#define OPT_SCN_RADIO_SRC_X		 496
#define OPT_SCN_RADIO_ON_SRC_Y   240
#define OPT_SCN_RADIO_OFF_SRC_Y  256
#define OPT_SCN_RADIO_WIDTH		  16
#define OPT_SCN_RADIO_HEIGHT	  16
// Kana/Kanji searches
#define OPT_RADIO_01_TEXT_X		(HELP_X + OPT_SCN_RADIO_WIDTH)  // Kana Search Any Pos
#define OPT_RADIO_01_TEXT_Y		(HELP_Y + (LINE_SPACE_IF_Y * 3))
#define OPT_RADIO_01_TEXT_WIDTH   87
#define OPT_RADIO_02_TEXT_X		(HELP_X + OPT_SCN_RADIO_WIDTH)  // Kana Search From Start
#define OPT_RADIO_02_TEXT_Y		(HELP_Y + (LINE_SPACE_IF_Y * 4))
#define OPT_RADIO_02_TEXT_WIDTH   75
// Foundset and Study List sorting
#define OPT_RADIO_03_TEXT_X		((AA_SCREEN_WIDTH / 2) + HELP_X + OPT_SCN_RADIO_WIDTH)	// Sort Orig
#define OPT_RADIO_03_TEXT_Y		(HELP_Y + (LINE_SPACE_IF_Y * 3))
#define OPT_RADIO_03_TEXT_WIDTH  100
#define OPT_RADIO_04_TEXT_X		((AA_SCREEN_WIDTH / 2) + HELP_X + OPT_SCN_RADIO_WIDTH)  // Sort Length
#define OPT_RADIO_04_TEXT_Y		(HELP_Y + (LINE_SPACE_IF_Y * 4))
#define OPT_RADIO_04_TEXT_WIDTH  100
#define OPT_RADIO_05_TEXT_X		((AA_SCREEN_WIDTH / 2) + HELP_X + OPT_SCN_RADIO_WIDTH)  // Sort Reading
#define OPT_RADIO_05_TEXT_Y		(HELP_Y + (LINE_SPACE_IF_Y * 5))
#define OPT_RADIO_05_TEXT_WIDTH  100

// Check Boxes
#define OPT_SCN_CHECK_SRC_X		 496
#define OPT_SCN_CHECK_ON_SRC_Y   272
#define OPT_SCN_CHECK_OFF_SRC_Y  288
#define OPT_SCN_CHECK_WIDTH		  16
#define OPT_SCN_CHECK_HEIGHT	  16

#define OPT_CHECK_01_TEXT_X		(HELP_X + OPT_SCN_CHECK_WIDTH)
#define OPT_CHECK_01_TEXT_Y		(HELP_Y + (LINE_SPACE_IF_Y * 7))
#define OPT_CHECK_01_TEXT_WIDTH 145// Need to check

#define OPT_CHECK_02_TEXT_X		((AA_SCREEN_WIDTH / 2) + HELP_X + OPT_SCN_CHECK_WIDTH)
#define OPT_CHECK_02_TEXT_Y		(HELP_Y + (LINE_SPACE_IF_Y * 7))
#define OPT_CHECK_02_TEXT_WIDTH 100// Need to check

// Added by Batanen
#define OPT_CHECK_03_TEXT_X		((AA_SCREEN_WIDTH / 2) + HELP_X + OPT_SCN_CHECK_WIDTH)
#define OPT_CHECK_03_TEXT_Y		(HELP_Y + (LINE_SPACE_IF_Y * 10))
#define OPT_CHECK_03_TEXT_WIDTH 35// Need to check
#define OPT_CHECK_04_TEXT_X		((AA_SCREEN_WIDTH / 2) + 50 + HELP_X + OPT_SCN_CHECK_WIDTH) 
#define OPT_CHECK_04_TEXT_Y		(HELP_Y + (LINE_SPACE_IF_Y * 10))
#define OPT_CHECK_04_TEXT_WIDTH 35// Need to check
#define OPT_CHECK_05_TEXT_X		((AA_SCREEN_WIDTH / 2) + 100 + HELP_X + OPT_SCN_CHECK_WIDTH)
#define OPT_CHECK_05_TEXT_Y		(HELP_Y + (LINE_SPACE_IF_Y * 10))
#define OPT_CHECK_05_TEXT_WIDTH 35// Need to check


// ==========
// Scrollbars
// ==========
// Body
#define SCROLLBAR_SRC_X				  464
#define SCROLLBAR_SRC_Y				   16
#define SCROLLBAR_WIDTH				   16
#define SCROLLBAR_HEIGHT			  192
#define SCROLLBAR_X					  456//450//(AA_SCREEN_WIDTH - SCROLLBAR_WIDTH - 8)
#define SCROLLBAR_Y					   60
// Body - Small
#define SCROLLBAR_SML_SRC_X			  480
#define SCROLLBAR_SML_SRC_Y            16
#define SCROLLBAR_SML_WIDTH             8
#define SCROLLBAR_SML_HEIGHT          135//166
#define SCROLLBAR_SML_X		          427//439//(AA_SCREEN_WIDTH - SCROLLBAR_WIDTH - 8)
#define SCROLLBAR_SML_Y			       65
// DOT
#define SCROLLBAR_DOT_SRC_X			  464
#define SCROLLBAR_DOT_SRC_Y           288
#define SCROLLBAR_DOT_WIDTH            16
#define SCROLLBAR_DOT_HEIGHT           16
#define SCROLLBAR_DOT_X		          452//(AA_SCREEN_WIDTH - SCROLLBAR_WIDTH - 8)
#define SCROLLBAR_DOT_OFFSET_X          2// NEW
#define SCROLLBAR_DOT_Y			       60
// DOT - Small
#define SCROLLBAR_SML_DOT_SRC_X		  480
#define SCROLLBAR_SML_DOT_SRC_Y       192
#define SCROLLBAR_SML_DOT_WIDTH         8
#define SCROLLBAR_SML_DOT_HEIGHT        8
#define SCROLLBAR_SML_DOT_X		      439//(AA_SCREEN_WIDTH - SCROLLBAR_WIDTH - 8)
#define SCROLLBAR_SML_DOT_OFFSET_X      0// NEW
#define SCROLLBAR_SML_DOT_Y		       65
// Scrollbar - Misc
#define SCROLLBAR_BODY				    0
#define SCROLLBAR_DOT				    1
#define SCROLLBAR_BIG				    0
#define SCROLLBAR_SML				    1

// Used by func IFPrintTextBox
#define MAX_PRINT_CHARS_X      32//35
#define MAX_PRINT_LINES        10// May need to change for Kanji Pop-up
#define WORD_WRAP               1
#define CHAR_WRAP               0

// ==============
// Saving/Loading
// ==============
#define MAX_SAVED_FILE_INDEX	  500
#define SAV_NO_FOUNDSET				1
#define SAV_CREATEFILELIST_ERR		2
#define SAV_FOUNDSET_EXISTS			3
#define SAV_FOPEN_ERR				4
#define SAV_FWRITE_COUNT_ERR		5
#define SAV_FWRITE_LIST_ERR			6

#define LOAD_ILLEGAL_INDEX			1
#define LOAD_FOPEN_ERR				2
#define LOAD_FREAD_COUNT_ERR		3
#define LOAD_FREAD_LIST_ERR			4
#define LOAD_STRRCHR_ERR			5

#define DEL_ILLEGAL_INDEX			1
#define DEL_FILE_NOT_FOUND          2
#define DEL_DID_NOT_DEL             3
#define DEL_CREATEFILELIST_ERR		4

#define CREATE_FL_MALLOC_ERR        1
#define CREATE_FL_DIR_ERR           2

// =================
// Screen Text Array
// =================
// Used for scrolling screen text.
#define MAX_SCREEN_TEXT		512
#define MAX_ST_HEIGHT		240//250 // CHECK
#define MAX_ST_HEIGHT_EDICT	260//250 // CHECK
#define MAX_ST_HEIGHT_POPUP 200 // CHECK
#define FONT_JAPANESE 0
#define FONT_LATIN 1


// ======================
// Study List Error codes
// ======================
#define STUDY_LIST_FULL_ERR					7
#define STUDY_LIST_EMPTY_ERR				8
#define STUDY_LIST_ENTRY_EXISTS_ERR			9
#define STUDY_LIST_CHK_CREATE_FILE_ERR		1
#define STUDY_LIST_CHK_LOAD_FILE_ERR		2

// ============
// Misc defines
// ============

#define TRUE -1
#define FALSE 0
#define RTN_OK -1

#define MAX_IND_NAME_LEN 60

#define MAX_FNAME_INDEX 25

#define AA_SCREEN_WIDTH  480
#define AA_SCREEN_HEIGHT 272
#define AA_MAX_TEXTURE_HEIGHT 512
#define MAX_FOUND   2002
#define MAX_NUM_STUDY_LIST 4
#define MAX_STUDY_LIST 2000
#define MAX_SHOWN_F  10
#define GET_KANA 1
#define GET_DESCRIP 2
#define DEF_KANJI_SIZE        1.0f

#define MAX_BUFFER     150
#define KDICT_SHOW_MAXTICKS 120
#define MAX_KEY_HELD_COUNT  320

#define TITLE_X				320
#define TITLE_Y				  0
#define TITLE_WIDTH			132
#define TITLE_HEIGHT		 32
#define TITLE_SCREENPOS_X   ((AA_SCREEN_WIDTH-TITLE_WIDTH)/2) // Just use half screen.
#define TITLE_SCREENPOS_Y	 20

#define HELP_X               35
#define HELP_Y               20
#define HELP_LIST_Y           5
#define SHOW_KDICT_RECT_X        42
#define SHOW_KDICT_RECT_Y        35
#define SHOW_KDICT_TEXT_X        (42 + 15)
#define SHOW_KDICT_TEXT_INDENT_X 15
#define SHOW_KDICT_TEXT_Y        (35 + 10)
#define SHOW_STROKE_TEXT_X        (8 + 15 + 80) // (42 + 15 + 80)
#define SHOW_SKIP_TEXT_X		(183 + 15 + 80) // Added by Batanen first is x-index
#define SHOW_KDICT_RECT_WIDTH   395
#define SHOW_KDICT_RECT_HEIGHT  200
#define SHOW_KDICT_MAX_LINES      7
#define KDICT_STROKE_OFFSET_X   47 //100
#define KDICT_SKIP_OFFSET_X		230

#define LINE_SPACE_Y         16
#define LINE_SPACE_IF_Y      20
#define LINE_IF_OFFSET_Y      4
#define SK_OFFSET_Y           6//3 // Found in ScreenUpdate() and DrawScreenTextEdict()
#define PRINT_CHAR_WIDTH      9.6
#define NEXT_PG_ARROW_Y       (AA_SCREEN_HEIGHT - 12) // Was 36
#define BOTTOM_LINE_Y       265

#define MAX_IFTB_HEIGHT			(8*LINE_SPACE_IF_Y)

#define OSK_JAPANESE                0
#define OSK_ENGLISH                 1

#define _strlwr strlwr


// ==================
// typedefs and enums
// ==================
typedef struct ukanjitag
{
	u8 *k_kanji;
	u8 *k_kana;
	char *e_descrip;
	long TCfilepos[MAX_TC_FILEPOS_COUNT];// Could go dynamic. See how this works first. // Added 7/11/09
} ukanji;

typedef struct ukanjidicttag
{
	u8 kanji[3];// Kanji will always be represented by two-byte sjis
	short int num_strokes;
	u8 *OnYomi;
	u8 *KunYomi;
	char *e_descrip;
	int skipCode[3];
}ukanjidict;

typedef struct aabuttontag
{
    int x;
    int y;
	int sourcex;
	int sourcey;
	int source_selx;
	int source_sely;
	int width;
	int height;
	int text_index; // Should default to -1. Will need to remember to check, otherwise will get out of bounds error.
	int mouse_over;
	int btn_enabled; // Will the button be greyed out. 0 == Yes, 1 == No
	int show_btn; // Should the button be shown/input processed at all. 0 == No, 1 == Yes
	char text[MAX_IND_NAME_LEN];
} aabutton;

typedef struct aacursortag
{
	int x;
	int y;
	int sourcex;
	int sourcey;
	int width;
	int height;
	int enabled;
	int mouse_over; // Added as using this for menu icons also.
	int origx;
	int origy;
} aacursor;

typedef struct uscreenkanjitag
{
    int index;
	int start_x;
	int start_y;
	int num_chars;
	int kanji_type;// Added 7/11/09 due to TC examples
} uscreenkanji;


typedef struct ustudylisteltag
{
    int index;
	short marked;
} ustudylistel;

typedef struct screentexteltag
{
    int x; // Basically, these are not really used in this project.
	int y;
	int offset_y;
	int font_type;//OSL_FONT *font;
	char *text;
	// Attributes for oslIntraFontSetStyle(OSL_FONT *f, float size, unsigned int color, unsigned int shadowColor, unsigned int options);
	float size;
	unsigned int color;
	unsigned int shadowColor;
	unsigned int options;
} uscreentextel;

// To be part of uTC below...
typedef struct uTCWordtag
{
	u8 *k_kanji;
	u8 *k_kana;
	int sense_num;
	u8 *form;
	int good; // True or False for good match for the word.
	//struct uTCWordtag *NextWord;
} uTCWord;

typedef struct uTCtag
{
    u8 *j_scentence;
	char *e_scentence;
	int ID;
	long file_pos;
	short file_num;
	uTCWord *word;
} uTC;


// Load/Save file stuff.
enum FileType {
	AAID_UNKNOWN,
	AAID_TXT,
	AAID_MP3,
	AAID_PEL, // PSPEdict List file.
	AAID_PE2, // FoundSet Computer Terms
	AAID_PE3, // FoundSet Legal Terms
	AAID_PE4, // FoundSet Life Sciences
	AAID_PE5, // FoundSet Custom
	AAID_ANY
};

enum SortType {
	OPT_SORT_ORIG,
	OPT_SORT_LENGTH,
	OPT_SORT_READING
};

enum GameStatus {		// GS_Level
	GS_INIT,			// NA
	GS_INTRO,			// NA
	GS_SETUP,			// NA
	GS_TEST,			// NA - Used for testing only
	GS_HELP,			// Level 2/5
	GS_RESET,			// NA
	GS_OPTIONS,			// Level 5
	GS_SHOW_FILES,		// Level 4
	GS_SHOW_EDICT_FILES,// Level 4 // NEW
	GS_LOAD_EDICT,		// Level 4 // NEW
	GS_SHOW_OSK,		// Level 4 // Doesn't override GS_SHOW_FILES, as both can't be run from the other.
	GS_SEARCHING,		// Level 4
	GS_SHOW_KANJIDICT,	// Level 1
	GS_PLAYING,			// Level 1 // Main Edict.
	GS_SHOW_SEL,		// Level 3
	GS_SHOW_RESULTS,	// Level 2		// Search results, the found set.
	GS_SHOW_STUDYLIST,	// Level 2
	GS_SHOW_SKIP		// Level 2	// For showing results when seached SKIP-codes or number of strokes.
};

enum KANJILISTING {
	NONE,		// DON'T SHOW
	NORMAL,		// SHOW ALL KANJIS
	STROKES,	// SHOW BY STROKES
	SKIPCODE	// SHOW BY SKIP
};

// used for game status levels (depth of game status, sort of like menu depth).
enum eGS_Level { // New 24/10/09
	GS_LEVEL_01,
	GS_LEVEL_02,
	GS_LEVEL_03,
	GS_LEVEL_04,
	GS_LEVEL_05
};

#define MAX_LEVEL       5

enum eEdictType {
	EDICT_ORIG,
	EDICT_COMP,
	EDICT_LEGAL,
	EDICT_LIFE,
	EDICT_CUSTOM
	//EDICT_NAMES
};

#define MAX_EDICT       5

#define TC_KANJI	0
#define EDICT_KANJI 1


// =====================
// Function declarations
// =====================
int LoadEdict(void);
int LoadKanjidict(void);
int LoadTCLine(char *filepath, long filepos, uTC *tmpTC);// Tanaka Corpus Example stuff. Added 7/11/09

int doInit(void);
int doInit2(void);
//int doReset(void);

void ScreenUpdate(void);
void CheckButtons(void);
int CheckMenu(int *tmp_game_status, OSL_CONTROLLER *keys);
void CheckKanjiPopup(void);
int CheckKanjiPopupInput(OSL_CONTROLLER *keys);
void DrawScrollbars(int x, int y, int length, int size_type, int index, int total);
void DrawCursor(void);
void DrawTitle(int x, int y);
void DrawMenu(void);
void DrawKanjiPopup(void);
void ClearScreenKanjiList(void);

// Helper Functions
int cursorInRange(int cx, int cy, int x0, int y0, int x1, int y1);
void doCleanup(void);
int GetPrevGS(int start_gs_level); // New 24/10/09
void ReturnToPrevGS(void); // New 24/10/09
void SetBaseGS(int tmp_game_status); // New 24/10/09
void SetGS(int level, int tmp_game_status, int clear_above); // New 24/10/09
int GetCurGSLevel(void);
int GetPrevGSLevel(int start_gs_level);

// Found Set
int SaveFoundSet(void);
int LoadFoundSet(void);
int DeleteFoundSet(void);
int getExtId(char *szFilePath);
int CreateFileList(char *dirstr, int FileExtFilter);
int CheckFileExists(char *file_fullpathname);
void ResetFoundSet(void);

// Study List
int CheckStudyLists(void);// Done at startup - Do after checking Edict and Kanjidic
int CreateDefaultStudyList(int edict_type, int listnum);
int LoadAllStudyLists(int edict_type);
int LoadStudyList(int edict_type, int listnum);
int SaveStudyList(int edict_type, int listnum);
int AddToStudyList(int listnum, int edict_index);
int DelFromStudyList(int listnum, int list_index); // Use a negative list_index to delete all.

// Printing
// These may actually achieve the same thing. Need to test - TODO
int IFPrintTextBox(int x0, int y0, int max_width, int max_height, const char *text);
int IFPrintTextBoxSJIS(int x0, int y0, int max_width, int max_height, const char *text);
int GetIFPrintTextBoxSJISLineWidth(int x0, int y0, int max_width, int max_height, const char *text, int line_num);

// Screen Text
int SetupScreenTextEdict(int index);
int SetupScreenTextKdic(void);
int SetupScreenTextPopup(void);
int DrawScreenTextEdict(int index);
int DrawScreenTextKdic(void);
int DrawScreenTextPopup(void);
int IFSetupScreenTextBox(uscreentextel tmp_st, int max_width, int max_height, const char *text);
int SetupScreenGSHELP(void);
int DrawScreenTextHelp(void);
int HasKanji(u8 *string);

// Searching
int search_kanjidict(u8 *search_str);
int find_eng_string(char *search_str, int whole_string);
//int find_SJIS_string(u8 *search_str, int s_type);
int find_SJIS_string(u8 *search_str, int s_type, int whole_string);
//int find_kanji_string(u8 *search_str, int s_type);
int find_kanji_string(u8 *search_str, int s_type, int whole_string);
int basic_UCS2toSJIS(unsigned short *instr, char *outstr);

// For using with qsort
int found_compare_length(const void *arg1, const void *arg2);
int found_compare_reading(const void *arg1, const void *arg2);
int found_compare_orig(const void *arg1, const void *arg2);
int kanjidict_compare_stroke(const void *arg1, const void *arg2);
int kanjidict_compare_orig(const void *arg1, const void *arg2);
int PD_wcscmp(const u8* cs, u8* ct);

// Ini File stuff
int INI_Check(void);
void INI_SetDefaults(void);
int INI_Load(void);
int INI_Create(void);
int INI_Save(void);


